/* date formart */
function dateFormat(fmt, day) {
    var date = new Date(day) || new Date();
    var o = {
        "M+": date.getMonth() + 1, //月份           
        "d+": date.getDate(), //日           
        "h+": date.getHours() % 12 === 0 ? 12 : date.getHours() % 12, //小时           
        "H+": date.getHours(), //小时           
        "m+": date.getMinutes(), //分           
        "s+": date.getSeconds(), //秒           
        "q+": Math.floor((date.getMonth() + 3) / 3), //季度           
        "S": date.getMilliseconds() //毫秒           
    };
    var week = {
        "0": "\u65e5",
        "1": "\u4e00",
        "2": "\u4e8c",
        "3": "\u4e09",
        "4": "\u56db",
        "5": "\u4e94",
        "6": "\u516d"
    };
    if (/(y+)/.test(fmt)) {
        fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
    if (/(E+)/.test(fmt)) {
        fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "\u661f\u671f" : "\u5468") : "") + week[date.getDay() + ""]);
    }
    for (var k in o) {
        if (new RegExp("(" + k + ")").test(fmt)) {
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
        }
    }
    return fmt;
}

/* myDatetimePicker */
(function($) {
    // today information
    var today = new Date(),
        tYear = today.getFullYear(),
        tMonth = today.getMonth() + 1,
        tDay = today.getDate(),
        tHours = today.getHours(),
        tMinite = today.getMinutes();

    function formatNumber(n) {
        return n < 10 ? "0" + n : n;
    }


    // init days 
    function initDays() {
        var days = [];
        for (var i = 0; i < 7; i++) {
            var tempDay = new Date();
            tempDay.setDate(tDay + i);
            days.push(tempDay.getFullYear() + '-' + formatNumber(tempDay.getMonth() + 1) + '-' + formatNumber(tempDay.getDate()));
        }

        return days;
    }

    function initDisplayDays() {
        var days = ['今天', '明天', '后天'];
        for (var i = 3; i < 7; i++) {
            var tempDay = new Date();
            tempDay.setDate(tDay + i);
            days.push((tempDay.getMonth() + 1) + '月' + tempDay.getDate() + '日');
        }

        return days;
    }


    // init hours
    function initHours() {
        var hours = [];
        for (var i = 0; i < 24; i++) {
            hours.push(i);
        }

        return hours;
    }

    function initDisplayHours(startHours) {
        var hours = [];
        for (var i = 0; i < 24; i++) {
            hours.push(i + '时');
        }

        return hours;
    }

    // init minites
    function initMinites(startMinite) {
        var minites = [];
        for (var i = 0; i < 60; i++) {
            minites.push(i);
        }
        return minites;
    }

    function initDisplayMinites(startMinite) {
        var minites = [];
        for (var i = 0; i < 60; i++) {
            minites.push(formatNumber(i) + '分');
        }
        return minites;
    }

    var defaults = {

        rotateEffect: false, //为了性能
        onChange: function(picker, values, displayValues) {
            var currentDay = picker.cols[0].displayValue;
            var currentHours = picker.cols[2].value;
            var currentMinite = picker.cols[4].value;

            var today = new Date(),
                tYear = today.getFullYear(),
                tMonth = today.getMonth() + 1,
                tDay = today.getDate(),
                tHours = today.getHours(),
                tMinite = today.getMinutes();

            if (currentDay == '今天') {
                if (currentHours < tHours) {
                    picker.cols[2].setValue(tHours);
                    picker.cols[4].setValue(tMinite);
                }

                if (currentHours == tHours && currentMinite < tMinite) {
                    picker.cols[4].setValue(tMinite);
                }
            }
            var dispalyTime = picker.cols[0].displayValue + '' + picker.cols[2].displayValue + ' ' + picker.cols[4].displayValue;
            $('#pg-demand-publish .pg-time-info .show-time').html(dispalyTime);
        },

        cols: [
            // Days
            {
                textAlign: 'center',
                values: initDays(),
                displayValues: initDisplayDays()
            },

            // Space divider
            {
                divider: true,
                content: '  '
            },

            // Hours
            {
                textAlign: 'center',
                values: initHours(),
                displayValues: initDisplayHours()
            },

            // Space divider
            {
                divider: true,
                content: '  '
            },

            // Minites
            {
                textAlign: 'center',
                values: initMinites(),
                displayValues: initDisplayMinites()
            }
        ]
    };

    $.fn.yunDatePicker = function(params) {
        return this.each(function() {
            if (!this) return;
            var p = $.extend(defaults, params);
            $(this).picker(p);
        });
    };
})(Zepto);

/* yes or no confirm */
(function($) {
    $.yonConfirm = function(text, callbackOk, callbackCancel) {
        if (typeof title === 'function') {
            callbackCancel = arguments[2];
            callbackOk = arguments[1];
            title = undefined;
        }
        return $.modal({
            text: text || '',
            buttons: [
                { text: '否', onClick: callbackCancel },
                { text: '是', bold: true, onClick: callbackOk }
            ]
        });
    };

    // 显示星评
    $.fn.displayStar = function(num) {
        var self = $(this);

        for (var i = 5; i > num; i--) {
            self.children('span').eq(i-1).addClass('grey');
        }
        return self;
    };
})(Zepto);

var Zeus = Zeus || {};
Zeus.constants = Zeus.constants || {};
Zeus.utils = Zeus.utils || {};

//var BASEURL = 'http://192.168.9.59:8080/zeus';
var BASEURL = 'http://zeus.pig84.com';
var BASEURL = 'http://test.pig84.com';
//var BASEURL = 'http://192.168.9.200:8080/zeus';
 var BASEURL = 'http://test.pig84.com';
// test: BASEURL = 'http://test.pig84.com';
// ci: BASEURL = 'http://zeus.pig84.cn';

Zeus.constants.BASEURL = BASEURL;
Zeus.constants.API_URL = Zeus.constants.BASEURL + '/api/v1';
Zeus.constants.IMG_URL = Zeus.constants.BASEURL + '/image';

Zeus.user = Zeus.user || {};

Zeus.driver = Zeus.driver || {};
Zeus.user.orderStatusName = {
    "PUBLISH": '发布中',
    "BIDDING": '抢单中',
    "WAITING": '待发车',
    "TAKING": '取货中',
    "TRANSIT": '送货中',
    "ABORT": '已取消',
    "CONFIRMING": '待评价',
    "FINISH": '已完成',
};

Zeus.driver.orderStatusName = {
    "PUBLISH": '发布中',
    "BIDDING": '抢单中',
    "WAITING": '待发车',
    "TAKING": '取货中',
    "TRANSIT": '送货中',
    "ABORT": '已取消',
    "CONFIRMING": '确认卸货',
    "FINISH": '已完成',
};

/* some common function */
Zeus.utils.getUrlPara = function getUrlPara(name) {
    var n = self.location.href.indexOf("?");
    var para = '';
    if (n >= 0) {
        para = "&" + self.location.href.substr(n + 1);
        n = para.indexOf("&" + name + "=");
        if (n >= 0) {
            para = para.substr(n + ("&" + name + "=").length) + "&";
            n = para.indexOf("&");
            if (n >= 0) {
                para = para.substr(0, n);
                return para.split('#')[0];
            }
        }
    }
    return '';
};

Zeus.utils.xhrAlert = function xhrAlert(xhr) {
    $.alert(xhr.responseText || '网络错误,请重试');
};

Zeus.utils.phoneFormat = function phoneFormat(value) {
    if (value.length != 11) {
        return value;
    } else {
        value = value.toString();
        return value.slice(0, 3) + '-' + value.slice(3, 7) + '-' + value.slice(7);
    }
};

Zeus.utils.pageLoad = function pageLoad(callback) {
    var pageNum = 1;

    return function() {
        callback(pageNum);
        pageNum++;
    };
};

Zeus.utils.getCity = function getCity(callback, BMap) {
    var cityName = '';
    var geolocation = new BMap.Geolocation();
    geolocation.getCurrentPosition(function(r) {
        if (this.getStatus() == BMAP_STATUS_SUCCESS) {
            cityName = r.address.city;
            callback(cityName);
        } else {
            var city = new BMap.LocalCity();
            city.get(function(r) {
                cityName = r.name;
                callback(cityName);
            });
        }
    });
};

Zeus.utils.getGeolocation = function getGeolocation(callback, BMap) {
    var geolocation = new BMap.Geolocation();
    geolocation.getCurrentPosition(function(r) {
        if (this.getStatus() == BMAP_STATUS_SUCCESS) {
            callback({
                "para": {
                    "city": r.address.city,
                    "district": r.address.district,
                    "name": r.address.street + r.address.street_number,
                    "location": { "lng": r.longitude, "lat": r.latitude }
                },
                "display": r.address.city + r.address.district + r.address.street + r.address.street_number,
            });
        } else {
            var city = new BMap.LocalCity();
            city.get(function(r) {
                callback({
                    "para": {
                        "city": r.name,
                        "district": '',
                        "name": '',
                        "location": { "lng": r.center.lng, "lat": r.center.lat }
                    },
                    "display": r.name,
                });
            });
        }
    });
};

Zeus.utils.phoneFormat = function phoneFormat(value) {
    if (!value) return;
    if (value.length != 11) {
        return value;
    } else {
        value = value.toString();
        return value.slice(0, 3) + '-' + value.slice(3, 7) + '-' + value.slice(7);
    }
};

Zeus.utils.isWechat = function() {
    return typeof WeixinJSBridge != 'undefined';
};

Zeus.utils.closeOrJump = function(url) {
    if (Zeus.utils.isWechat()) WeixinJSBridge.invoke('closeWindow');
    else window.location.href = url;
};

Zeus.utils.close = function close() {
    if (Zeus.utils.isWechat()) WeixinJSBridge.invoke('closeWindow');
    else window.close();
};

Zeus.utils.onBack = function(url) {
    var pageId = history.state.pageId;
    var t = Date.now();
    window.addEventListener('popstate', function(ev) {
        var d = Date.now() - t; // Quirk on some device
        if (d > 200 && history.state.pageId == pageId) {
            if (url) window.location.href = url;
            else Zeus.utils.close();
        }
    });
    history.pushState({ pageId: pageId }, '');
    Zeus.utils.hideWeixinOptionMenu(); // Since current page's URL is changed, we must disable the option menu which including Refresh button
};

Zeus.utils.hideWeixinOptionMenu = function hideWeixinOptionMenu() {
    function onBridgeReady() {
        WeixinJSBridge.call('hideOptionMenu');
    }

    if (typeof WeixinJSBridge == "undefined") {
        if (document.addEventListener) {
            document.addEventListener('WeixinJSBridgeReady', onBridgeReady, false);
        } else if (document.attachEvent) {
            document.attachEvent('WeixinJSBridgeReady', onBridgeReady);
            document.attachEvent('onWeixinJSBridgeReady', onBridgeReady);
        }
    } else {
        onBridgeReady();
    }
};

Zeus.utils.formatNum = function formatNum(num) {
    return num < 10 ? ('0' + num) : num;
};

Zeus.utils.parseDate = function(datestr) {
    if (!datestr) return;
    var tokens = datestr.split(' ');
    var dts = tokens[0].split('-');
    var tts = tokens[1].split(':');
    return new Date(dts[0], parseInt(dts[1]) - 1, dts[2], tts[0], tts[1], tts[2]);
};

// XXX This function is not a good idea
Zeus.utils.dateWithoutSeconds = function(datestr) {
    var d = Zeus.utils.parseDate(datestr);
    var hours = d.getHours();
    hours = Zeus.utils.formatNum(hours);
    var mins = d.getMinutes();
    mins = Zeus.utils.formatNum(mins);
    return d.getFullYear() + '-' + (d.getMonth() + 1) + '-' + d.getDate() + ' ' + hours + ':' + mins;
};

Zeus.utils.Account = {

    authShipper: function(fn) {
        this.auth('users', fn);
    },

    authDriver: function(fn) {
        this.auth('drivers', fn);
    },

    auth: function(type, fn) {
        var self = this;
        var sid = this.get();
        if (!sid) {
            self.forceLogin();
            // We dont call the callback function since jumping immediately
        }
        $.ajax({
            url: Zeus.utils.assembleApi('/' + type + '/me'),
            success: function(data) {
                if (!data) {
                    self.clear();
                    self.forceLogin();
                    return;
                }
                fn(data);
            }
        });
    },

    get: function() {
        return localStorage.getItem('sid');
    },

    set: function(sid) {
        localStorage.setItem('sid', sid);
    },

    clear: function() {
        localStorage.removeItem('sid');
    },

    forceLogin: function() {
        this.setHistory(window.location.href);
        window.location.href = 'regester.html';
    },

    getHistory: function(defaultPage) {
        return localStorage.getItem('history') || defaultPage;
    },
    setHistory: function(history) {
        localStorage.setItem('history', history);
    }
};

Zeus.utils.assembleApi = function(api) {
    var url = Zeus.constants.API_URL + api;
    var sid = Zeus.utils.Account.get();
    if (!sid) return url;

    var signal = url.indexOf('?') >= 0 ? '&' : '?';
    url += signal + 'sid=' + sid;
    return url;
};



/* page init */
$(function() {
    // avoid keyboard hide input
    if ($.device.android) {
        $('input,textarea').bind('click', function(e) {
            var $this = $(this);
            setTimeout(function() {
                $('.page-current .content').scrollTop($this.offset().top - 10);
            }, 200);
        });
    }
    // sui mobile init
    $.init();

    // Check whether should onBack
    var hash = window.location.hash;
    var pos = hash.indexOf('#onback');
    if (pos >= 0) {
        if (Zeus.utils.isWechat()) {
            Zeus.utils.onBack();
            return;
        }
        var url = hash.substring(pos + '#onback-'.length);
        Zeus.utils.onBack(url);
    }
});
