$(function() {
    // render order list
    function renderOrderList(data, type) {
        var template = [],
            status = Zeus.driver.orderStatusName[data.status],
            time = data.time.split(' '),
            locFrom = data.from.city + data.from.district + data.from.name,
            locTo = data.to.city + data.to.district + data.to.name;

        template.push('<li data-orderid="');
        template.push(data.id);
        template.push('"><div class="order-title"><div class="publisher">');
        template.push('<span class="day">' + time[0].slice(5, 7) + '月' + time[0].slice(8) + '日' + '</span>');
        template.push('<span class="time">' + time[1].slice(0, 2) + ':' + time[1].slice(3,5) + '</span>');
        template.push('</div><span class="pull-right">');
        template.push(status);
        template.push('</span></div>');
        template.push('<div class="order-content"><p><span class="icon from">始</span>');
        template.push(locFrom);
        template.push('</p><p><span class="icon to">终</span>');
        template.push(locTo);
        template.push('</p><ul><li>');
        template.push(data.vType.carName);
        if (data.distanceValue) {
            template.push('</li><li>');
            template.push(data.distanceValue + '公里');
        }
        if (data.timeValue) {
            template.push('</li><li>');
            template.push(Math.round(data.timeValue * 60) + '分钟');
        }
        template.push('</li></ul>');
        template.push('<div class="date">');
        template.push('¥<span class="price-num">' + data.price + '</span>');
        template.push('<div>');
        template.push('</div>');
        template = template.join('');
        if (type) {
            $('#order-in .order-list').append(template);
        } else {
            $('#order-out .order-list').append(template);
        }
    }

    var getOrderIn = Zeus.utils.pageLoad(function(pageNum) {
        // render order list
        $.ajax({
            url: Zeus.utils.assembleApi('/drivers/me/orders'),
            data: {
                type: 'UNDERWAY',
                currentPage: pageNum
            },
            success: function(data) {
                if (pageNum === 1 && data.length === 0) {
                    $('#order-in .order-list').append('<div class="no-data">暂时没有进行中的订单</div>');
                    return;
                }
                if (data.length === 0) return;
                data.forEach(function(e) {
                    renderOrderList(e, true);
                });
            }
        });
    });

    var getOrderOut = Zeus.utils.pageLoad(function(pageNum) {
        $.ajax({
            url: Zeus.utils.assembleApi('/drivers/me/orders'),
            data: {
                type: 'COMPLETED',
                currentPage: pageNum
            },
            success: function(data) {
                if (pageNum === 1 && data.length === 0) {
                    $('#order-out .order-list').append('<div class="no-data">暂时没有完成的订单</div>');
                    return;
                }
                if (data.length === 0) return;
                data.forEach(function(e) {
                    renderOrderList(e, false);
                });
            }
        });
    });

    $(document).on("pageInit", "#pg-order-list", function(e, id, page) {
        getOrderIn();
        getOrderOut();
        $(page).on('infinite', function() {
            if ($(this).find('.infinite-scroll.active').attr('id') == "order-in") {
                getOrderIn();
            }
            if ($(this).find('.infinite-scroll.active').attr('id') == "order-out") {
                getOrderOut();
            }
            $.refreshScroller();
        });
    });

    // router to order detail
    $(document).on('click', '#order-in .order-list > li', function() {
        var orderId = $(this).data('orderid');
        document.location.href = 'orderDetail.html?orderId=' + orderId;
    });    

    $(document).on('click', '#order-out .order-list > li', function() {
        var orderId = $(this).data('orderid');
        document.location.href = 'orderDetail.html?orderId=' + orderId;
    });

});
